diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 34ca6d4ac2..d424450e7b 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -3325,8 +3537,9 @@ create_bitmap_scan_plan(PlannerInfo *root,
  * messy, since we'd have to build new RestrictInfos in many cases.)
  */
 static Plan *
-create_bitmap_subplan(PlannerInfo *root, Path *bitmapqual,
-					  List **qual, List **indexqual, List **indexECs)
+create_bitmap_subplan(CreatePlanContext *context, PlannerInfo *root,
+					  Path *bitmapqual, List **qual, List **indexqual,
+					  List **indexECs)
 {
 	Plan	   *plan;
 
@@ -3353,7 +3566,7 @@ create_bitmap_subplan(PlannerInfo *root, Path *bitmapqual,
 			List	   *subindexqual;
 			List	   *subindexEC;
 
-			subplan = create_bitmap_subplan(root, (Path *) lfirst(l),
+			subplan = create_bitmap_subplan(context, root, (Path *) lfirst(l),
 											&subqual, &subindexqual,
 											&subindexEC);
 			subplans = lappend(subplans, subplan);
@@ -3400,7 +3613,7 @@ create_bitmap_subplan(PlannerInfo *root, Path *bitmapqual,
 			List	   *subindexqual;
 			List	   *subindexEC;
 
-			subplan = create_bitmap_subplan(root, (Path *) lfirst(l),
+			subplan = create_bitmap_subplan(context, root, (Path *) lfirst(l),
 											&subqual, &subindexqual,
 											&subindexEC);
 			subplans = lappend(subplans, subplan);
@@ -3466,7 +3679,7 @@ create_bitmap_subplan(PlannerInfo *root, Path *bitmapqual,
 
 		/* Use the regular indexscan plan build machinery... */
 		iscan = castNode(IndexScan,
-						 create_indexscan_plan(root, ipath,
+						 create_indexscan_plan(context, root, ipath,
 											   NIL, NIL, false));
 		/* then convert to a bitmap indexscan */
 		plan = (Plan *) make_bitmap_indexscan(iscan->scan.scanrelid,
@@ -3533,8 +3746,8 @@ create_bitmap_subplan(PlannerInfo *root, Path *bitmapqual,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static TidScan *
-create_tidscan_plan(PlannerInfo *root, TidPath *best_path,
-					List *tlist, List *scan_clauses)
+create_tidscan_plan(CreatePlanContext *context, PlannerInfo *root,
+					TidPath *best_path, List *tlist, List *scan_clauses)
 {
 	TidScan    *scan_plan;
 	Index		scan_relid = best_path->path.parent->relid;
@@ -3620,6 +3833,7 @@ create_tidscan_plan(PlannerInfo *root, TidPath *best_path,
 							 tidquals);
 
 	copy_generic_path_info(&scan_plan->scan.plan, &best_path->path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -3630,8 +3844,8 @@ create_tidscan_plan(PlannerInfo *root, TidPath *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static TidRangeScan *
-create_tidrangescan_plan(PlannerInfo *root, TidRangePath *best_path,
-						 List *tlist, List *scan_clauses)
+create_tidrangescan_plan(CreatePlanContext *context, PlannerInfo *root,
+						 TidRangePath *best_path, List *tlist, List *scan_clauses)
 {
 	TidRangeScan *scan_plan;
 	Index		scan_relid = best_path->path.parent->relid;
@@ -3685,6 +3899,7 @@ create_tidrangescan_plan(PlannerInfo *root, TidRangePath *best_path,
 								  tidrangequals);
 
 	copy_generic_path_info(&scan_plan->scan.plan, &best_path->path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -3695,7 +3910,8 @@ create_tidrangescan_plan(PlannerInfo *root, TidRangePath *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static SubqueryScan *
-create_subqueryscan_plan(PlannerInfo *root, SubqueryScanPath *best_path,
+create_subqueryscan_plan(CreatePlanContext *context, PlannerInfo *root,
+						 SubqueryScanPath *best_path,
 						 List *tlist, List *scan_clauses)
 {
 	SubqueryScan *scan_plan;
@@ -3712,7 +3928,7 @@ create_subqueryscan_plan(PlannerInfo *root, SubqueryScanPath *best_path,
 	 * a different planner context (subroot), recurse to create_plan not
 	 * create_plan_recurse.
 	 */
-	subplan = create_plan(rel->subroot, best_path->subpath);
+	subplan = create_plan(context, rel->subroot, best_path->subpath);
 
 	/* Sort clauses into best execution order */
 	scan_clauses = order_qual_clauses(root, scan_clauses);
@@ -3735,6 +3951,7 @@ create_subqueryscan_plan(PlannerInfo *root, SubqueryScanPath *best_path,
 								  subplan);
 
 	copy_generic_path_info(&scan_plan->scan.plan, &best_path->path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -3745,8 +3962,8 @@ create_subqueryscan_plan(PlannerInfo *root, SubqueryScanPath *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static FunctionScan *
-create_functionscan_plan(PlannerInfo *root, Path *best_path,
-						 List *tlist, List *scan_clauses)
+create_functionscan_plan(CreatePlanContext *context, PlannerInfo *root,
+						 Path *best_path, List *tlist, List *scan_clauses)
 {
 	FunctionScan *scan_plan;
 	Index		scan_relid = best_path->parent->relid;
@@ -3778,6 +3995,7 @@ create_functionscan_plan(PlannerInfo *root, Path *best_path,
 								  functions, rte->funcordinality);
 
 	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -3788,8 +4006,8 @@ create_functionscan_plan(PlannerInfo *root, Path *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static TableFuncScan *
-create_tablefuncscan_plan(PlannerInfo *root, Path *best_path,
-						  List *tlist, List *scan_clauses)
+create_tablefuncscan_plan(CreatePlanContext *context, PlannerInfo *root,
+						  Path *best_path, List *tlist, List *scan_clauses)
 {
 	TableFuncScan *scan_plan;
 	Index		scan_relid = best_path->parent->relid;
@@ -3821,6 +4039,7 @@ create_tablefuncscan_plan(PlannerInfo *root, Path *best_path,
 								   tablefunc);
 
 	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -3831,8 +4050,8 @@ create_tablefuncscan_plan(PlannerInfo *root, Path *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static ValuesScan *
-create_valuesscan_plan(PlannerInfo *root, Path *best_path,
-					   List *tlist, List *scan_clauses)
+create_valuesscan_plan(CreatePlanContext *context, PlannerInfo *root,
+					   Path *best_path, List *tlist, List *scan_clauses)
 {
 	ValuesScan *scan_plan;
 	Index		scan_relid = best_path->parent->relid;
@@ -3865,6 +4084,7 @@ create_valuesscan_plan(PlannerInfo *root, Path *best_path,
 								values_lists);
 
 	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -3875,7 +4095,8 @@ create_valuesscan_plan(PlannerInfo *root, Path *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static CteScan *
-create_ctescan_plan(PlannerInfo *root, Path *best_path,
+create_ctescan_plan(CreatePlanContext *context,
+					PlannerInfo *root, Path *best_path,
 					List *tlist, List *scan_clauses)
 {
 	CteScan    *scan_plan;
@@ -3959,6 +4180,7 @@ create_ctescan_plan(PlannerInfo *root, Path *best_path,
 							 plan_id, cte_param_id);
 
 	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -3970,7 +4192,8 @@ create_ctescan_plan(PlannerInfo *root, Path *best_path,
  *	'tlist'.
  */
 static NamedTuplestoreScan *
-create_namedtuplestorescan_plan(PlannerInfo *root, Path *best_path,
+create_namedtuplestorescan_plan(CreatePlanContext *context,
+								PlannerInfo *root, Path *best_path,
 								List *tlist, List *scan_clauses)
 {
 	NamedTuplestoreScan *scan_plan;
@@ -3998,6 +4221,7 @@ create_namedtuplestorescan_plan(PlannerInfo *root, Path *best_path,
 										 rte->enrname);
 
 	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -4009,8 +4233,8 @@ create_namedtuplestorescan_plan(PlannerInfo *root, Path *best_path,
  *	'tlist'.
  */
 static Result *
-create_resultscan_plan(PlannerInfo *root, Path *best_path,
-					   List *tlist, List *scan_clauses)
+create_resultscan_plan(CreatePlanContext *context, PlannerInfo *root,
+					   Path *best_path, List *tlist, List *scan_clauses)
 {
 	Result	   *scan_plan;
 	Index		scan_relid = best_path->parent->relid;
@@ -4036,6 +4260,7 @@ create_resultscan_plan(PlannerInfo *root, Path *best_path,
 	scan_plan = make_result(tlist, (Node *) scan_clauses, NULL);
 
 	copy_generic_path_info(&scan_plan->plan, best_path);
+	scan_plan->plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -4046,8 +4271,8 @@ create_resultscan_plan(PlannerInfo *root, Path *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static WorkTableScan *
-create_worktablescan_plan(PlannerInfo *root, Path *best_path,
-						  List *tlist, List *scan_clauses)
+create_worktablescan_plan(CreatePlanContext *context, PlannerInfo *root,
+						  Path *best_path, List *tlist, List *scan_clauses)
 {
 	WorkTableScan *scan_plan;
 	Index		scan_relid = best_path->parent->relid;
@@ -4096,6 +4321,7 @@ create_worktablescan_plan(PlannerInfo *root, Path *best_path,
 								   cteroot->wt_param_id);
 
 	copy_generic_path_info(&scan_plan->scan.plan, best_path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return scan_plan;
 }
@@ -4106,8 +4332,8 @@ create_worktablescan_plan(PlannerInfo *root, Path *best_path,
  *	 with restriction clauses 'scan_clauses' and targetlist 'tlist'.
  */
 static ForeignScan *
-create_foreignscan_plan(PlannerInfo *root, ForeignPath *best_path,
-						List *tlist, List *scan_clauses)
+create_foreignscan_plan(CreatePlanContext *context, PlannerInfo *root,
+						ForeignPath *best_path, List *tlist, List *scan_clauses)
 {
 	ForeignScan *scan_plan;
 	RelOptInfo *rel = best_path->path.parent;
@@ -4119,7 +4345,8 @@ create_foreignscan_plan(PlannerInfo *root, ForeignPath *best_path,
 
 	/* transform the child path if any */
 	if (best_path->fdw_outerpath)
-		outer_plan = create_plan_recurse(root, best_path->fdw_outerpath,
+		outer_plan = create_plan_recurse(context, root,
+										 best_path->fdw_outerpath,
 										 CP_EXACT_TLIST);
 
 	/*
@@ -4149,13 +4376,15 @@ create_foreignscan_plan(PlannerInfo *root, ForeignPath *best_path,
 	 * has selected some join clauses for remote use but also wants them
 	 * rechecked locally).
 	 */
-	scan_plan = rel->fdwroutine->GetForeignPlan(root, rel, rel_oid,
+	scan_plan = rel->fdwroutine->GetForeignPlan(context,
+												root, rel, rel_oid,
 												best_path,
 												tlist, scan_clauses,
 												outer_plan);
 
 	/* Copy cost data from Path to Plan; no need to make FDW do this */
 	copy_generic_path_info(&scan_plan->scan.plan, &best_path->path);
+	scan_plan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	/* Copy user OID to access as; likewise no need to make FDW do this */
 	scan_plan->checkAsUser = rel->userid;
@@ -4261,8 +4490,8 @@ create_foreignscan_plan(PlannerInfo *root, ForeignPath *best_path,
  * Transform a CustomPath into a Plan.
  */
 static CustomScan *
-create_customscan_plan(PlannerInfo *root, CustomPath *best_path,
-					   List *tlist, List *scan_clauses)
+create_customscan_plan(CreatePlanContext *context, PlannerInfo *root,
+					   CustomPath *best_path, List *tlist, List *scan_clauses)
 {
 	CustomScan *cplan;
 	RelOptInfo *rel = best_path->path.parent;
@@ -4272,7 +4501,8 @@ create_customscan_plan(PlannerInfo *root, CustomPath *best_path,
 	/* Recursively transform child paths. */
 	foreach(lc, best_path->custom_paths)
 	{
-		Plan	   *plan = create_plan_recurse(root, (Path *) lfirst(lc),
+		Plan	   *plan = create_plan_recurse(context, root,
+											   (Path *) lfirst(lc),
 											   CP_EXACT_TLIST);
 
 		custom_plans = lappend(custom_plans, plan);
@@ -4301,6 +4531,7 @@ create_customscan_plan(PlannerInfo *root, CustomPath *best_path,
 	 * do this
 	 */
 	copy_generic_path_info(&cplan->scan.plan, &best_path->path);
+	cplan->scan.plan.est_calls = clamp_row_est(context->est_calls);
 
 	/* Likewise, copy the relids that are represented by this custom scan */
 	cplan->custom_relids = best_path->path.parent->relids;
@@ -4332,28 +4563,32 @@ create_customscan_plan(PlannerInfo *root, CustomPath *best_path,
  *****************************************************************************/
 
 static NestLoop *
-create_nestloop_plan(PlannerInfo *root,
+create_nestloop_plan(CreatePlanContext *context,
+					 PlannerInfo *root,
 					 NestPath *best_path)
 {
-	NestLoop   *join_plan;
-	Plan	   *outer_plan;
-	Plan	   *inner_plan;
-	List	   *tlist = build_path_tlist(root, &best_path->jpath.path);
-	List	   *joinrestrictclauses = best_path->jpath.joinrestrictinfo;
-	List	   *joinclauses;
-	List	   *otherclauses;
-	Relids		outerrelids;
-	List	   *nestParams;
-	Relids		saveOuterRels = root->curOuterRels;
+	CreatePlanContext	inner_context;
+	NestLoop   			*join_plan;
+	Plan	   			*outer_plan;
+	Plan	   			*inner_plan;
+	List	   			*tlist = build_path_tlist(root, &best_path->jpath.path);
+	List	   			*joinrestrictclauses = best_path->jpath.joinrestrictinfo;
+	List	   			*joinclauses;
+	List	   			*otherclauses;
+	Relids				 outerrelids;
+	List	   			*nestParams;
+	Relids				 saveOuterRels = root->curOuterRels;
 
 	/* NestLoop can project, so no need to be picky about child tlists */
-	outer_plan = create_plan_recurse(root, best_path->jpath.outerjoinpath, 0);
+	outer_plan = create_plan_recurse(context, root, best_path->jpath.outerjoinpath, 0);
 
 	/* For a nestloop, include outer relids in curOuterRels for inner side */
 	root->curOuterRels = bms_union(root->curOuterRels,
 								   best_path->jpath.outerjoinpath->parent->relids);
 
-	inner_plan = create_plan_recurse(root, best_path->jpath.innerjoinpath, 0);
+	copy_create_plan_context(&inner_context, context);
+	inner_context.est_calls = context->est_calls * outer_plan->plan_rows;
+	inner_plan = create_plan_recurse(&inner_context, root, best_path->jpath.innerjoinpath, 0);
 
 	/* Restore curOuterRels */
 	bms_free(root->curOuterRels);
@@ -4403,12 +4638,14 @@ create_nestloop_plan(PlannerInfo *root,
 							  best_path->jpath.inner_unique);
 
 	copy_generic_path_info(&join_plan->join.plan, &best_path->jpath.path);
+	join_plan->join.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return join_plan;
 }
 
 static MergeJoin *
-create_mergejoin_plan(PlannerInfo *root,
+create_mergejoin_plan(CreatePlanContext *context,
+					  PlannerInfo *root,
 					  MergePath *best_path)
 {
 	MergeJoin  *join_plan;
@@ -4440,10 +4677,10 @@ create_mergejoin_plan(PlannerInfo *root,
 	 * best to request a small tlist so we aren't sorting more data than
 	 * necessary.
 	 */
-	outer_plan = create_plan_recurse(root, best_path->jpath.outerjoinpath,
+	outer_plan = create_plan_recurse(context, root, best_path->jpath.outerjoinpath,
 									 (best_path->outersortkeys != NIL) ? CP_SMALL_TLIST : 0);
 
-	inner_plan = create_plan_recurse(root, best_path->jpath.innerjoinpath,
+	inner_plan = create_plan_recurse(context, root, best_path->jpath.innerjoinpath,
 									 (best_path->innersortkeys != NIL) ? CP_SMALL_TLIST : 0);
 
 	/* Sort join qual clauses into best execution order */
@@ -4498,7 +4735,8 @@ create_mergejoin_plan(PlannerInfo *root,
 	if (best_path->outersortkeys)
 	{
 		Relids		outer_relids = outer_path->parent->relids;
-		Sort	   *sort = make_sort_from_pathkeys(outer_plan,
+		Sort	   *sort = make_sort_from_pathkeys(context,
+												   outer_plan,
 												   best_path->outersortkeys,
 												   outer_relids);
 
@@ -4512,7 +4750,8 @@ create_mergejoin_plan(PlannerInfo *root,
 	if (best_path->innersortkeys)
 	{
 		Relids		inner_relids = inner_path->parent->relids;
-		Sort	   *sort = make_sort_from_pathkeys(inner_plan,
+		Sort	   *sort = make_sort_from_pathkeys(context,
+												   inner_plan,
 												   best_path->innersortkeys,
 												   inner_relids);
 
@@ -4537,6 +4776,7 @@ create_mergejoin_plan(PlannerInfo *root,
 		 * sync with final_cost_mergejoin.)
 		 */
 		copy_plan_costsize(matplan, inner_plan);
+		inner_plan->est_calls = clamp_row_est(context->est_calls);
 		matplan->total_cost += cpu_operator_cost * matplan->plan_rows;
 
 		inner_plan = matplan;
@@ -4710,12 +4950,14 @@ create_mergejoin_plan(PlannerInfo *root,
 
 	/* Costs of sort and material steps are included in path cost already */
 	copy_generic_path_info(&join_plan->join.plan, &best_path->jpath.path);
+	join_plan->join.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return join_plan;
 }
 
 static HashJoin *
-create_hashjoin_plan(PlannerInfo *root,
+create_hashjoin_plan(CreatePlanContext *context,
+					 PlannerInfo *root,
 					 HashPath *best_path)
 {
 	HashJoin   *join_plan;
@@ -4742,10 +4984,10 @@ create_hashjoin_plan(PlannerInfo *root,
 	 * we anticipate batching, request a small tlist from the outer side so
 	 * that we don't put extra data in the outer batch files.
 	 */
-	outer_plan = create_plan_recurse(root, best_path->jpath.outerjoinpath,
+	outer_plan = create_plan_recurse(context, root, best_path->jpath.outerjoinpath,
 									 (best_path->num_batches > 1) ? CP_SMALL_TLIST : 0);
 
-	inner_plan = create_plan_recurse(root, best_path->jpath.innerjoinpath,
+	inner_plan = create_plan_recurse(context, root, best_path->jpath.innerjoinpath,
 									 CP_SMALL_TLIST);
 
 	/* Sort join qual clauses into best execution order */
@@ -4883,6 +5125,7 @@ create_hashjoin_plan(PlannerInfo *root,
 							  best_path->jpath.inner_unique);
 
 	copy_generic_path_info(&join_plan->join.plan, &best_path->jpath.path);
+	join_plan->join.plan.est_calls = clamp_row_est(context->est_calls);
 
 	return join_plan;
 }
@@ -6133,7 +6376,8 @@ make_incrementalsort(Plan *lefttree, int numCols, int nPresortedCols,
  * or a Result stacked atop lefttree).
  */
 static Plan *
-prepare_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
+prepare_sort_from_pathkeys(CreatePlanContext *context,
+						   Plan *lefttree, List *pathkeys,
 						   Relids relids,
 						   const AttrNumber *reqColIdx,
 						   bool adjust_tlist_in_place,
@@ -6257,7 +6501,8 @@ prepare_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
 			{
 				/* copy needed so we don't modify input's tlist below */
 				tlist = copyObject(tlist);
-				lefttree = inject_projection_plan(lefttree, tlist,
+				lefttree = inject_projection_plan(context,
+												  lefttree, tlist,
 												  lefttree->parallel_safe);
 			}
 
@@ -6315,7 +6560,8 @@ prepare_sort_from_pathkeys(Plan *lefttree, List *pathkeys,
  *	  'relids' is the set of relations required by prepare_sort_from_pathkeys()
  */
 static Sort *
-make_sort_from_pathkeys(Plan *lefttree, List *pathkeys, Relids relids)
+make_sort_from_pathkeys(CreatePlanContext *context, Plan *lefttree,
+						List *pathkeys, Relids relids)
 {
 	int			numsortkeys;
 	AttrNumber *sortColIdx;
@@ -6324,7 +6570,8 @@ make_sort_from_pathkeys(Plan *lefttree, List *pathkeys, Relids relids)
 	bool	   *nullsFirst;
 
 	/* Compute sort column info, and adjust lefttree as needed */
-	lefttree = prepare_sort_from_pathkeys(lefttree, pathkeys,
+	lefttree = prepare_sort_from_pathkeys(context,
+										  lefttree, pathkeys,
 										  relids,
 										  NULL,
 										  false,
@@ -6350,7 +6597,8 @@ make_sort_from_pathkeys(Plan *lefttree, List *pathkeys, Relids relids)
  *	  'nPresortedCols' is the number of presorted columns in input tuples
  */
 static IncrementalSort *
-make_incrementalsort_from_pathkeys(Plan *lefttree, List *pathkeys,
+make_incrementalsort_from_pathkeys(CreatePlanContext *context,
+								   Plan *lefttree, List *pathkeys,
 								   Relids relids, int nPresortedCols)
 {
 	int			numsortkeys;
@@ -6360,7 +6608,8 @@ make_incrementalsort_from_pathkeys(Plan *lefttree, List *pathkeys,
 	bool	   *nullsFirst;
 
 	/* Compute sort column info, and adjust lefttree as needed */
-	lefttree = prepare_sort_from_pathkeys(lefttree, pathkeys,
+	lefttree = prepare_sort_from_pathkeys(context,
+										  lefttree, pathkeys,
 										  relids,
 										  NULL,
 										  false,
@@ -7260,3 +7509,10 @@ is_projection_capable_plan(Plan *plan)
 	}
 	return true;
 }
+
+static void
+copy_create_plan_context(CreatePlanContext *dest, CreatePlanContext *src)
+{
+	dest->est_calls = src->est_calls;
+	dest->jit = src->jit;
+}
\ No newline at end of file
diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
index 6f45efde21..5f2e4d211a 100644
--- a/src/backend/optimizer/plan/planner.c
+++ b/src/backend/optimizer/plan/planner.c
@@ -295,6 +295,7 @@ standard_planner(Query *parse, const char *query_string, int cursorOptions,
 	Plan	   *top_plan;
 	ListCell   *lp,
 			   *lr;
+	CreatePlanContext context;
 
 	/*
 	 * Set up global state for this planner invocation.  This data is needed
@@ -417,7 +418,8 @@ standard_planner(Query *parse, const char *query_string, int cursorOptions,
 	final_rel = fetch_upper_rel(root, UPPERREL_FINAL, NULL);
 	best_path = get_cheapest_fractional_path(final_rel, tuple_fraction);
 
-	top_plan = create_plan(root, best_path);
+	context.est_calls = 1.0;
+	top_plan = create_plan(&context, root, best_path);
 
 	/*
 	 * If creating a plan for a scrollable cursor, make sure it can run
@@ -559,9 +561,17 @@ standard_planner(Query *parse, const char *query_string, int cursorOptions,
 	result->stmt_location = parse->stmt_location;
 	result->stmt_len = parse->stmt_len;
 
+	/*
+	 * Decision to perform JIT is made at plan node level. Whereas JIT inlining
+	 * and optimization are done either for the whole query or not done at all.
+	 * 
+	 * If the total cost is greater than jit_above_cost, performing JIT is
+	 * allowed but not guaranteed. Whether JIT performed on a node is decided
+	 * in create_plan().
+	 * 
+	 */
 	result->jitFlags = PGJIT_NONE;
-	if (jit_enabled && jit_above_cost >= 0 &&
-		top_plan->total_cost > jit_above_cost)
+	if (jit_enabled && context.jit)
 	{
 		result->jitFlags |= PGJIT_PERFORM;
 
diff --git a/src/backend/optimizer/plan/subselect.c b/src/backend/optimizer/plan/subselect.c
index 7a9fe88fec..4a8126fcf1 100644
--- a/src/backend/optimizer/plan/subselect.c
+++ b/src/backend/optimizer/plan/subselect.c
@@ -172,6 +172,7 @@ make_subplan(PlannerInfo *root, Query *orig_subquery,
 	Plan	   *plan;
 	List	   *plan_params;
 	Node	   *result;
+	CreatePlanContext context;
 
 	/*
 	 * Copy the source Query node.  This is a quick and dirty kluge to resolve
@@ -233,7 +234,8 @@ make_subplan(PlannerInfo *root, Query *orig_subquery,
 	final_rel = fetch_upper_rel(subroot, UPPERREL_FINAL, NULL);
 	best_path = get_cheapest_fractional_path(final_rel, tuple_fraction);
 
-	plan = create_plan(subroot, best_path);
+	context.est_calls = 1.0;
+	plan = create_plan(&context, subroot, best_path);
 
 	/* And convert to SubPlan or InitPlan format. */
 	result = build_subplan(root, plan, subroot, plan_params,
@@ -284,7 +286,8 @@ make_subplan(PlannerInfo *root, Query *orig_subquery,
 				AlternativeSubPlan *asplan;
 
 				/* OK, finish planning the ANY subquery */
-				plan = create_plan(subroot, best_path);
+				context.est_calls = 1.0;
+				plan = create_plan(&context, subroot, best_path);
 
 				/* ... and convert to SubPlan format */
 				hashplan = castNode(SubPlan,
@@ -907,6 +910,7 @@ SS_process_ctes(PlannerInfo *root)
 		Plan	   *plan;
 		SubPlan    *splan;
 		int			paramid;
+		CreatePlanContext context;
 
 		/*
 		 * Ignore SELECT CTEs that are not actually referenced anywhere.
@@ -997,7 +1001,8 @@ SS_process_ctes(PlannerInfo *root)
 		final_rel = fetch_upper_rel(subroot, UPPERREL_FINAL, NULL);
 		best_path = final_rel->cheapest_total_path;
 
-		plan = create_plan(subroot, best_path);
+		context.est_calls = 1.0;
+		plan = create_plan(&context, subroot, best_path);
 
 		/*
 		 * Make a SubPlan node for it.  This is just enough unlike
diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
index 0b1d17b9d3..c9befc4348 100644
--- a/src/backend/optimizer/util/pathnode.c
+++ b/src/backend/optimizer/util/pathnode.c
@@ -1626,6 +1626,12 @@ create_memoize_path(PlannerInfo *root, RelOptInfo *rel, Path *subpath,
 	 */
 	pathnode->est_entries = 0;
 
+	/* 
+	 * We initially set est_hitratio to 0. An estimate will be determined by 
+	 * cost_memoize_rescan() later.
+	 */
+	pathnode->est_hitratio = 0;
+
 	/*
 	 * Add a small additional charge for caching the first entry.  All the
 	 * harder calculations for rescans are performed in cost_memoize_rescan().
diff --git a/src/include/foreign/fdwapi.h b/src/include/foreign/fdwapi.h
index 996c62e305..0f4ac3a1df 100644
--- a/src/include/foreign/fdwapi.h
+++ b/src/include/foreign/fdwapi.h
@@ -18,7 +18,7 @@
 
 /* To avoid including explain.h here, reference ExplainState thus: */
 struct ExplainState;
-
+struct CreatePlanContext;
 
 /*
  * Callback function signatures --- see fdwhandler.sgml for more info.
@@ -32,7 +32,8 @@ typedef void (*GetForeignPaths_function) (PlannerInfo *root,
 										  RelOptInfo *baserel,
 										  Oid foreigntableid);
 
-typedef ForeignScan *(*GetForeignPlan_function) (PlannerInfo *root,
+typedef ForeignScan *(*GetForeignPlan_function) (struct CreatePlanContext *context,
+												 PlannerInfo *root,
 												 RelOptInfo *baserel,
 												 Oid foreigntableid,
 												 ForeignPath *best_path,
diff --git a/src/include/nodes/pathnodes.h b/src/include/nodes/pathnodes.h
index ed85dc7414..3b06d7e10b 100644
--- a/src/include/nodes/pathnodes.h
+++ b/src/include/nodes/pathnodes.h
@@ -1969,6 +1969,8 @@ typedef struct MemoizePath
 	uint32		est_entries;	/* The maximum number of entries that the
 								 * planner expects will fit in the cache, or 0
 								 * if unknown */
+	double		est_hitratio;	/* The estimate of how many call will result in
+								 * cache hit */
 } MemoizePath;
 
 /*
diff --git a/src/include/nodes/plannodes.h b/src/include/nodes/plannodes.h
index d40af8e59f..cf973cc4f7 100644
--- a/src/include/nodes/plannodes.h
+++ b/src/include/nodes/plannodes.h
@@ -127,6 +127,8 @@ typedef struct Plan
 	 */
 	Cost		startup_cost;	/* cost expended before fetching any tuples */
 	Cost		total_cost;		/* total cost (assuming all tuples fetched) */
+	double		est_calls;		/* estimated number of times this plan will be
+								 * (re)scanned */
 
 	/*
 	 * planner's estimate of result size of this plan step
@@ -145,6 +147,11 @@ typedef struct Plan
 	 */
 	bool		async_capable;	/* engage asynchronous-capable logic? */
 
+	/*
+	 * information needed for jit
+	 */
+	bool		jit;			/* jit compile for this plan node? */
+
 	/*
 	 * Common structural data for all Plan types.
 	 */
diff --git a/src/include/optimizer/planmain.h b/src/include/optimizer/planmain.h
index 2bc857745a..728ddc4345 100644
--- a/src/include/optimizer/planmain.h
+++ b/src/include/optimizer/planmain.h
@@ -39,12 +39,28 @@ extern void preprocess_minmax_aggregates(PlannerInfo *root);
 /*
  * prototypes for plan/createplan.c
  */
-extern Plan *create_plan(PlannerInfo *root, Path *best_path);
+typedef struct CreatePlanContext
+{
+	/* 
+	 * Input fields used for passing information down through the plan
+	 */
+	double est_calls;
+
+	/*
+	 * Output fields used for returning information up
+	 */
+	bool jit;
+} CreatePlanContext;
+
+extern Plan *create_plan(CreatePlanContext *context,
+						 PlannerInfo *root,
+						 Path *best_path);
 extern ForeignScan *make_foreignscan(List *qptlist, List *qpqual,
 									 Index scanrelid, List *fdw_exprs, List *fdw_private,
 									 List *fdw_scan_tlist, List *fdw_recheck_quals,
 									 Plan *outer_plan);
-extern Plan *change_plan_targetlist(Plan *subplan, List *tlist,
+extern Plan *change_plan_targetlist(CreatePlanContext *context,
+									Plan *subplan, List *tlist,
 									bool tlist_parallel_safe);
 extern Plan *materialize_finished_plan(Plan *subplan);
 extern bool is_projection_capable_path(Path *path);
